# -*- coding: utf-8 -*-
"""tf_DeepLOB_fp32_TPU.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1QQU5HgTcmLgwMUL9hlygRtm18xq47VOJ
"""

#from google.colab import drive
from google.cloud import storage
import io

project_id = 'upbeat-sunup-372508'
# from google.colab import auth
# auth.authenticate_user()

import tensorflow as tf
import pandas as pd
import numpy as np
from matplotlib import pyplot as plt
from keras.utils import np_utils
from keras.models import Model, load_model
from keras.optimizers import Adam
from keras.layers import Input, Conv2D, LeakyReLU, MaxPooling2D, concatenate, LSTM, Reshape, Dense
from keras.callbacks import EarlyStopping

import sys
import os
os.environ["GCLOUD_PROJECT"] = "upbeat-sunup-372508"
import json
import tempfile
import time

#https://www.tensorflow.org/guide/tpu#input_datasets
resolver = tf.distribute.cluster_resolver.TPUClusterResolver(tpu='')
tf.config.experimental_connect_to_cluster(resolver)
tf.tpu.experimental.initialize_tpu_system(resolver)
print("All devices: ", tf.config.list_logical_devices('TPU'))
strategy = tf.distribute.TPUStrategy(resolver)

sys.path.append(os.getcwd())

#drive.mount('/content/drive', force_remount=True)
# drive.mount("/ShardDrives/", force_remount=True)

# PATH = os.path.join(os.getcwd() , '/content/drive/MyDrive/upbeat-sunup-372508-48faf8bf4bca.json')
# os.environ['GOOGLE_APPLICATION_CREDENTIALS'] = PATH

# storage_client = storage.Client(PATH)
# storage_client

def get_hyperParams():
    lr = 0.05
    hyper_params = {
        'lookback_timestep' : 100,
        'feature_num' : 40,

        #Conv param
        'conv_filter_num' : 16,

        #Inception module param
        'inception_num' : 32,

        #LSTM param
        'LSTM_num' : 64,

        #Activation param
        'leaky_relu_alpha' : 0.01,

        # categorical crossentropy loss
        'loss' : 'categorical_crossentropy',

        # ADAM is used
        'learning_rate' : lr,
        'adam_epsilon' : 1,
        'optimizer' :  Adam(lr=lr, epsilon=1),

        # accuracy is used for stopping training
        'metrics' : ['accuracy'],

        #max epoch num is not specified in paper, use 120 because paper mentions training stops at about 100 epochs
        'num_epoch' : 64,
        #stop training when validation accuracy does not improve for 20 epochs
        'stop_epoch_num' : 50,
        #mini-batch size 32 from paper
        'batch_size' : 512,
    }
    return hyper_params


def initiate_DeepLOB_model(lookback_timestep, feature_num, conv_filter_num, inception_num, LSTM_num, leaky_relu_alpha,
                          loss, optimizer, metrics, strategy, dtype=tf.float32):
    #with strategy.scope():
    
    input_tensor = Input(shape=(lookback_timestep, feature_num, 1), dtype=dtype, name='data')
    
    # Conv block1
    # print(input_tensor.shape)
    conv_layer1 = Conv2D(conv_filter_num, (1,2), strides=(1, 2), dtype=dtype)(input_tensor)
    conv_layer1 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer1)
    # print(conv_layer1.shape)
    conv_layer1 = Conv2D(conv_filter_num, (4,1), padding='same', dtype=dtype)(conv_layer1)
    conv_layer1 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer1)
    # print(conv_layer1.shape)
    conv_layer1 = Conv2D(conv_filter_num, (4,1), padding='same', dtype=dtype)(conv_layer1)
    conv_layer1 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer1)
    # print("conv_layer1.shape: ", conv_layer1.shape)

    # Conv block2
    conv_layer2 = Conv2D(conv_filter_num, (1,2), strides=(1, 2), dtype=dtype)(conv_layer1)
    conv_layer2 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer2)
    # print(conv_layer2.shape)
    conv_layer2 = Conv2D(conv_filter_num, (4,1), padding='same', dtype=dtype)(conv_layer2)
    conv_layer2 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer2)
    # print(conv_layer2.shape)
    conv_layer2 = Conv2D(conv_filter_num, (4,1), padding='same', dtype=dtype)(conv_layer2)
    conv_layer2 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer2)
    # print("conv_layer2.shape: ", conv_layer2.shape)

    # Conv block3
    conv_layer3 = Conv2D(conv_filter_num, (1,10), dtype=dtype)(conv_layer2)
    conv_layer3 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer3)
    # print(conv_layer3.shape)
    conv_layer3 = Conv2D(conv_filter_num, (4,1), padding='same', dtype=dtype)(conv_layer3)
    conv_layer3 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer3)
    # print(conv_layer3.shape)
    conv_layer3 = Conv2D(conv_filter_num, (4,1), padding='same', dtype=dtype)(conv_layer3)
    conv_layer3 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(conv_layer3)
    # print("conv_layer3.shape: ", conv_layer3.shape)
    
    # Inception module
    inception_module1 = Conv2D(inception_num, (1,1), padding='same', dtype=dtype)(conv_layer3)
    inception_module1 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(inception_module1)
    # print(inception_module1.shape)
    inception_module1 = Conv2D(inception_num, (3,1), padding='same', dtype=dtype)(inception_module1)
    inception_module1 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(inception_module1)
    # print("inception_module1.shape: ", inception_module1.shape)

    inception_module2 = Conv2D(inception_num, (1,1), padding='same', dtype=dtype)(conv_layer3)
    inception_module2 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(inception_module2)
    # print(inception_module2.shape)
    inception_module2 = Conv2D(inception_num, (5,1), padding='same', dtype=dtype)(inception_module2)
    inception_module2 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(inception_module2)
    # print("inception_module2.shape: ", inception_module2.shape)

    inception_module3 = MaxPooling2D((3,1), strides=(1,1), padding='same', dtype=dtype)(conv_layer3)
    # print(inception_module3.shape)
    inception_module3 = Conv2D(inception_num, (1,1), padding='same', dtype=dtype)(inception_module3)
    # print(inception_module3.shape)
    inception_module3 = LeakyReLU(alpha=leaky_relu_alpha, dtype=dtype)(inception_module3)
    # print("inception_module3.shape: ", inception_module3.shape)
    
    inception_module_final = concatenate([inception_module1, inception_module2, inception_module3], axis=3)
    # print(inception_module_final.shape)
    inception_module_final = Reshape((inception_module_final.shape[1], inception_module_final.shape[3]), dtype=dtype)(inception_module_final)
    # print("inception_module_final.shape: ", inception_module_final.shape)

    # LSTM
    LSTM_output = LSTM(LSTM_num, dtype=dtype)(inception_module_final)
    # print("LSTM_output.shape: ", LSTM_output.shape)

    # Fully Connected Layer with softmax activation function for output
    model_output = Dense(3, activation='softmax', dtype=dtype)(LSTM_output)
    # print("model_output.shape: ", model_output.shape)
    
    DeepLOB_model = Model(inputs=input_tensor, outputs= model_output)  
    
    DeepLOB_model.compile(optimizer=optimizer, loss=loss, metrics=metrics)

    return DeepLOB_model

def tf_train(data_train, data_valid):
    hp = get_hyperParams()

    

    with strategy.scope():
      DeepLOB_model = initiate_DeepLOB_model(
        hp['lookback_timestep'], hp['feature_num'], hp['conv_filter_num'], 
        hp['inception_num'], hp['LSTM_num'], hp['leaky_relu_alpha'], hp['loss'], hp['optimizer'], hp['metrics'], strategy
      )
      #DeepLOB_model.summary()
      es = EarlyStopping(monitor='val_accuracy', mode='max', patience = hp['stop_epoch_num'], verbose=0)
      start = time.perf_counter()
      DeepLOB_model.fit(data_train, epochs=hp['num_epoch'], batch_size=hp['batch_size'], verbose=0, validation_data=(data_valid), callbacks = [es])
      end = time.perf_counter()
      print("Tensorflow Train Time: " ,end - start, " seconds")
    
    #DeepLOB_model.save('/content/drive/MyDrive/IE421/models/tf_DeepLOB_fp32.h5')

    return DeepLOB_model

def tf_test(data_test, model):
    start = time.perf_counter()
    loss, accuracy = model.evaluate(data_test, verbose=0)
    end = time.perf_counter()
    print("Tensorflow Train Time: " ,end - start, " seconds")
    return loss, accuracy

def parse_tfrecord(example):
  feature_description = {
      'data': tf.io.FixedLenFeature([100, 40], tf.float32),
      'label': tf.io.FixedLenFeature([3], tf.int64),
  }
  example = tf.io.parse_single_example(example, feature_description)
  data = example['data']
  label = example['label']
  return data, label

def cdRootDir():
    cur_dir = os.getcwd()
    while cur_dir != '/':
        os.chdir('../')
        cur_dir = os.getcwd()



def load_data():
#test_bucket43532

    # client = storage.Client()
    # bucket = client.bucket("test_bucket43532")

    train = tf.data.TFRecordDataset("gs://test_bucket43532/dif_train.tfrecord")
    test = tf.data.TFRecordDataset("gs://test_bucket43532/dif_test.tfrecord")
    valid = tf.data.TFRecordDataset("gs://test_bucket43532/dif_valid.tfrecord")


    def parse_tfrecord(example_proto):
      feature_description = {
          'features': tf.io.FixedLenFeature([100, 40, 1], tf.float32),
          'labels': tf.io.FixedLenFeature([3], tf.float32)
      }
      example = tf.io.parse_single_example(example_proto, feature_description)
      # feature = tf.reshape(example['feature'], [100, 40])
      # label = tf.reshape(example['label'], [3])
      data = example['features']
      label = example['labels']
      return data, label

    hp = get_hyperParams()
    batch_size = hp['batch_size']

    train = train.map(parse_tfrecord)
    train = train.batch(batch_size)
    train = train.prefetch(buffer_size=tf.data.AUTOTUNE)

    test = test.map(parse_tfrecord)
    test = test.batch(batch_size)
    test = test.prefetch(buffer_size=tf.data.AUTOTUNE)

    valid = valid.map(parse_tfrecord)
    valid = valid.batch(batch_size)
    valid = valid.prefetch(buffer_size=tf.data.AUTOTUNE)

    return train, test, valid

data_train, data_valid, data_test = load_data()
print(data_train)

model = tf_train(data_train, data_valid)

del data_train
del data_valid

load, accuracy = tf_test(data_test, model)
